import javafx.application.Application;

import javafx.geometry.Insets;

import javafx.scene.Scene;

import javafx.scene.control.Label;
import javafx.scene.control.Spinner;

import javafx.scene.layout.GridPane;

import javafx.stage.Stage;

import javafx.util.StringConverter;

public class SpinnerDemo extends Application
{
   @Override
   public void start(Stage primaryStage)
   {
      Spinner<Integer> ispinner = new Spinner<>(1, 10, 2);
      ispinner.setEditable(true);
      StringConverter<Integer> sci = ispinner.getValueFactory().getConverter();
      StringConverter<Integer> sci2 = new StringConverter<Integer>()
                                      {
                                         @Override
                                         public Integer fromString(String value)
                                         {
                                            try
                                            {
                                               return sci.fromString(value);
                                            }
                                            catch (NumberFormatException nfe)
                                            {
                                               System.out.println("Bad integer: " + 
                                                                  value);
                                               return 0;
                                            }
                                         }

                                         @Override
                                         public String toString(Integer value)
                                         {
                                            return sci.toString(value);
                                         }
                                      };
      ispinner.getValueFactory().setConverter(sci2);

      Spinner<Double> dspinner = new Spinner<>(1.5, 3.5, 1.5, 0.5);
      dspinner.setEditable(true);
      StringConverter<Double> scd = dspinner.getValueFactory().getConverter();
      StringConverter<Double> scd2 = new StringConverter<Double>()
                                     {
                                        @Override
                                        public Double fromString(String value)
                                        {
                                           try
                                           {
                                              return scd.fromString(value);
                                           }
                                           catch (RuntimeException re)
                                           {
                                              System.out.println("Bad double: " + 
                                                                 value);
                                              System.out.println("Cause: " + 
                                                                 re.getCause());
                                              return 0.0;
                                           }
                                        }

                                        @Override
                                        public String toString(Double value)
                                        {
                                           return scd.toString(value);
                                        }
                                     };
      dspinner.getValueFactory().setConverter(scd2);

      GridPane grid = new GridPane();
      grid.setHgap(10);
      grid.setVgap(10);
      grid.setPadding(new Insets(10));

      grid.add(new Label("Integer Spinner"), 0, 0);
      grid.add(ispinner, 1, 0);
      grid.add(new Label("Double Spinner"), 0, 1);
      grid.add(dspinner, 1, 1);

      Scene scene = new Scene(grid, 350, 100);
      primaryStage.setTitle("SpinnerDemo");
      primaryStage.setScene(scene);
      primaryStage.show();
   }
}