import java.util.function.UnaryOperator;

import javafx.application.Application;

import javafx.geometry.Insets;

import javafx.scene.Scene;

import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.TextFormatter;

import javafx.scene.layout.HBox;

import javafx.stage.Stage;

public class TextFormatterDemo extends Application
{
   @Override
   public void start(Stage primaryStage)
   {
      Label lblPhone = new Label("Phone");
      TextField txtPhone = new TextField("555-5555");
      UnaryOperator<TextFormatter.Change> filter;
      filter = new UnaryOperator<TextFormatter.Change>()
               {
                  @Override
                  public TextFormatter.Change apply(TextFormatter.Change change)
                  {
                     System.out.println(change);
                     String text = change.getText();
                     for (int i = 0; i < text.length(); i++)
                        if (!Character.isDigit(text.charAt(i)))
                          return null;
                     return change;
                  }
               };
      txtPhone.setTextFormatter(new TextFormatter<String>(filter));
      HBox hboxForm = new HBox(10);
      hboxForm.setPadding(new Insets(10, 10, 10, 10));
      hboxForm.getChildren().addAll(lblPhone, txtPhone);
      Scene scene = new Scene(hboxForm);
      primaryStage.setScene(scene);
      primaryStage.setResizable(false);
      primaryStage.setTitle("TextFormatterDemo");
      primaryStage.show();
   }
}