import java.util.function.UnaryOperator;

import javafx.application.Application;

import javafx.geometry.Insets;

import javafx.scene.Scene;

import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.TextFormatter;

import javafx.scene.layout.HBox;

import javafx.stage.Stage;

import javafx.util.StringConverter;

public class TextFormatterDemo extends Application
{
   @Override
   public void start(Stage primaryStage)
   {
      Label lblPhone = new Label("Phone");
      TextField txtPhone = new TextField("555-5555");
      StringConverter<String> formatter;
      formatter = new StringConverter<String>()
                  {
                     @Override
                     public String fromString(String string)
                     {
                        System.out.println("fromString(): string = " + string);
                        if (string.length() == 8)
                           return string;
                        else
                        if (string.length() == 7 && string.indexOf('-') == -1)
                           return string.substring(0, 3) + "-" + 
                                  string.substring(3);
                        else
                           return "333-3333";
                     }

                     @Override
                     public String toString(String object)
                     {
                        System.out.println("toString(): object = " + object);
                        if (object == null)   // only null when called from 
                           return "777-7777"; // TextFormatter constructor 
                                              // without default
                        System.out.println("object.tostring = " + 
                                           object.toString());
                        return object;
                     }
                  };
      UnaryOperator<TextFormatter.Change> filter;
      filter = new UnaryOperator<TextFormatter.Change>()
               {
                  @Override
                  public TextFormatter.Change apply(TextFormatter.Change change)
                  {
                     System.out.println(change);
                     String text = change.getText();
                     for (int i = 0; i < text.length(); i++)
                        if (!Character.isDigit(text.charAt(i)))
                          return null;
                     return change;
                  }
               };
      txtPhone.setTextFormatter(new TextFormatter<String>(formatter, "555-5555",
                                                          filter));
      HBox hboxForm = new HBox(10);
      hboxForm.setPadding(new Insets(10, 10, 10, 10));
      hboxForm.getChildren().addAll(lblPhone, txtPhone);
      Scene scene = new Scene(hboxForm);
      primaryStage.setScene(scene);
      primaryStage.setResizable(false);
      primaryStage.setTitle("TextFormatterDemo");
      primaryStage.show();
   }
}